				.586

.MODEL	FLAT, STDCALL

OPTION	CASEMAP :NONE   ;Case Sensitive

			include	uChipSimu.inc

Include	windows.inc
Include user32.inc
Include kernel32.inc
Include comctl32.inc

IncludeLib USER32.LIB
IncludeLib KERNEL32.LIB
IncludeLib comctl32.lib


IDD_MAIN		EQU 101
IDD_DLG1		EQU 102
IDD_DLG2		EQU 103
IDD_DLG3		EQU 104
IDC_OK			EQU 1001
IDC_TABCONTROL	EQU 1002
IDC_STATIC		EQU 1010
IDC_STATICONE	EQU 1004
IDC_EDITONE		EQU 1005
IDC_STATICTWO	EQU 1006
IDC_EDITTWO		EQU 1007
IDC_STATICTHREE	EQU 1008
IDC_EDITTHREE	EQU 1009

				.CODE

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;;
;; Random number generator
;;
;;      Gets last random number (seed) from EBP.
;;      Returns new random number in EAX.
;;      Stores it in EBP as the seed for the next call.
;;      Sets EDX = 0.
;;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
align   		DWORD
random  		proc    private

				mov     eax, 214013t
				imul    ebp
				sub     edx, edx                ; Prevent divide overflow by caller
				add     eax, 2531011t
				mov     ebp, eax
				ret

random			endp

;
; Initialise the random numbers
;
; syntax :
; call InitRndmNbr
;
; Return:
; eax = number of ticks since the computer started, and Seed defined
;
InitRndmNbr 	PROC
				push ecx
				push edx

				invoke GetTickCount
				test eax,eax 			; ) to be sure it's not zero (it's possible ! if you launch the program 48 days after you've started the computer, lol)
				jnz Label1 				; ) (and depending of the radom number routine, some really don't like zeros...)
				mov eax,123456789 		; )
Label1: 
				mov Seed,eax ; save the seed

				pop edx
				pop ecx
				ret
InitRndmNbr 	ENDP

;
; generate a random number
;
; syntax :
; mov ebx,Range
; call GetRndmNbr
;
; Return :
; eax = desired random number
;
GetRndmNbr 		PROC
				push	edx

				mov		eax,987654321	 	; a x value
				mul 	Seed 				; multiply eax by your Seed
				bswap 	eax 				; swap bytes (to not have a too easy suit)
				xor 	eax,078787878h 		; apply a mask
				mov 	Seed,eax 			; save the new RndmNbr as Seed, for next use

				; a range ?
				inc 	ebx
				jz 		Label2 ; if not jump Label2
				
				; here a range :
				mul 	ebx ; mul by range+1
				mov 	eax,edx ; return the result in eax
				; exit
Label2: 
				dec 	ebx ; restore ebx

				pop 	edx
				ret
GetRndmNbr		ENDP

;*==========================================================================*
;*			Routine to randomize the instructions							*
;*==========================================================================*
Randm_Instr		proc
				mov		ecx,MAX_INSTRUCTIONS	; ECX =total number of instructions
				
				sub		edx,edx					; offset to array
		randomlp:
				;*====	Randomize for instructions	====
				mov		ebx,4					; range of 4 instruction types
				call	GetRndmNbr				; get value for instruction type
				
				mov		esi,offset InstrList	; ESI -> instruction array
				mov		[esi+edx],al			; save random instruction number
				
				;*====	Randomize for port	====
				mov		ebx,4					; range of 4 port types
				call	GetRndmNbr				; get value for port type
				
				mov		esi,offset IPortList	; ESI -> port array
				mov		[esi+edx],al			; save random port number
				
				;*====	Randomize for bit number	====
				mov		ebx,8					; range of 8 bit numbers
				call	GetRndmNbr				; get value for bit type
				
				mov		esi,offset IBitList		; ESI -> bit array
				mov		[esi+edx],al			; save random bit number
				
				;*====	Randomize for data	====
				mov		ebx,255					; range of 8 data types
				call	GetRndmNbr				; get value for data type
				
				mov		esi,offset IDataList	; ESI -> data array
				mov		[esi+edx],al			; save random data number
				
				;*====	Randomize for data type	====
				mov		ebx,2					; range of 2 data types
				call	GetRndmNbr				; get value for data type
				
				mov		esi,offset IDTypList	; ESI -> data array
				mov		[esi+edx],al			; save random data type number

				;*====	Initialize the error list	====
				mov		esi,offset ErrLineList	; ESI -> error line array
				mov		byte ptr [esi+edx],00	; save random data type number

				mov		esi,offset ErrDataList	; ESI -> error data array
				mov		byte ptr [esi+edx],00	; save random data type number
								
				inc		edx						; increment offset
				dec		ecx						; decrement count
				jne		randomlp				; do for the rest
				ret
Randm_Instr		endp

;*==========================================================================*
;*			Routine to calculate offset to the string in array				*
;*--------------------------------------------------------------------------*
;*			Input: EDX = String number										*
;*			Output: EBX = Offset											*
;*==========================================================================*
get_stroffs		proc
				shl		edx,3					; x 8
				mov		ebx,edx					; copy into EBX
				shl		edx,1					; x 16
				add		ebx,edx					; x 24
				ret
get_stroffs		endp

;*==========================================================================*
;*			Routine to format the instructions for display					*
;*--------------------------------------------------------------------------*
;*			Variable: RunLine points to current set's start number			*
;*==========================================================================*
Format_Instr	proc
				sub		edx,edx					; reset EDX
				mov		ecx,25					; 25 lines
				
				sub		eax,eax					; reset EAX
				mov		al,[RunLine]			; load current running line number
				add		edx,eax					; EDX -> start of instruction arrays
				
				;**		Format instruction loop	====
		fmtinstrlp:
				push	edx						; save EDX
				push	ecx						;  & ECX
				
				call	get_stroffs				; EBX = offset to data
				
				;*====	Get port data type	====
				mov		esi,offset IDTypList	; ESI-> data type array
				mov		al,[esi+ebx]			; AL = port data type
				mov		[CurDTyp],al			; save the data type
				
				;*====	Get port data	====
				mov		esi,offset IDataList	; ESI-> data array
				mov		al,[esi+ebx]			; AL = port data 
				mov		[CurData],al			; save the data 
				
				;*====	Get bit number data	====
				mov		esi,offset IBitList		; ESI-> bit array
				mov		al,[esi+ebx]			; AL = bit data
				mov		[CurBit],al				; save the bit type
				
				;*====	Get port name data	====
				mov		esi,offset IPortList	; ESI-> port array
				mov		ah,[esi+ebx]			; AL = port data
				mov		[CurPort],ah			; save the port type
				
				;*====	Get instruction data	====
				mov		esi,offset InstrList	; ESI-> instruction array
				mov		al,[esi+ebx]			; AL = instruction data
				mov		[CurInstr],al			; save the instruction type
				
				;*====	Format the information into ASCII string	====
				;*====	Starting with the instruction				====
				mov		edi,offset InstrStr		; EDI -> instruction string
				mov		esi,offset szTris		; ESI -> point to TRIS instruction
				
				cmp		al,2					; check if it is a TRIS instruction?
				jb		fmtPort					; Yes, then format the TRIS instruction
				
				;*====	Default to port instruction	====
				mov		esi,offset szPort		; ESI -> point to Port
		fmtPort:
				mov		ecx,4					; 4 characters to copy
				rep		movsb					; copy it
				
				;*====	Now put the Port name	====
				mov		al,[CurPort]			; get port name
				add		al,41h					; encode with ASCII
				stosb							; write the port name
				
				;*====	Check type of instruction	====
				mov		esi,offset szBits		; ESI -> bits message
				cmp		[CurInstr],1			; TRIS bit instruction?
				je		fmtBitInstr				; Yes, then process it
				
				cmp		[CurInstr],3			; PORT bit instruction?
				jne		fmtInstr				; No, process for non bit instruction
				
				;*====	Process for bit type instruction	====
		fmtBitInstr:
				mov		ecx,5					; 5 characters for 'bits.'
				rep		movsb					; write into string instruction buffer
				
				;*====	Distinguish between TRIS or PORT bit type instruction	====
				mov		byte ptr [esi],'R'		; default to port bit instruction type
				
				mov		esi,offset szTris		; ESI -> tris message
				cmp		[CurInstr],1			; TRIS bit instruction?
				jne		fmtPbitInstr			; Yes, then process it
				
				mov		ecx,4					; 4 characters for TRIS
				rep		movsb					; copy into string buffer
				jmp		fmtbitDInstr			; continue
				
		fmtPbitInstr:
				inc		esi						; skip the character
				
				;*====	Put in the port name and bit number	====
		fmtbitDInstr:
				mov		ah,[CurPort]			; AH =Port name
				mov		al,[CurBit]				; AL = bit number
				add		ax,3030h				; encode in ASCII
				mov		word ptr [esi],ax		;
				mov		byte ptr [esi+2],20h	; add space
				mov		byte ptr [esi+3],'='	; 
				mov		byte ptr [esi+4],20h	; add space
				add		esi,5					; skip the characters copied in
				
				;*====	Write in the bit data	====
				mov		cl,[CurBit]				; CL = bit number
				mov		al,[CurData]			; AL = port data
				dec		cl						; shift the bit data to bit 0 position
				shr		al,cl					; 
				and		al,1					; mask out the rest of the data
				add		al,30h					; encode in ASCII
				stosb
				
				;*====	Terminate string	====
		fmtNullStr:
				mov		byte ptr [esi],20h		; space
				mov		byte ptr [esi+1],';'	; 
				mov		byte ptr [esi+2],0		; terminate string
				jmp		fmtInstnxt				; do the next instruction
				
				;*====	Process non-bit instruction	====
		fmtInstr:
				mov		byte ptr [esi],20h		; add space
				mov		byte ptr [esi+1],'='	; 
				mov		byte ptr [esi+2],20h	; add space
				add		esi,3					; skip the characters copied in
				
				;*===-	Determine the data type to display	====
				cmp		[CurDTyp],0				; display in binary?
				jne		fmtInstrHex				; No, display in hexadecimal
				
				;*====	Display the data in binary	====
				mov		ecx,8					; 8 bits to format
				mov		ah,[CurData]			; AL = data
		fmtBinary:
				sub		al,al					; reset AH
				shr		ah,1					; rotate into carry
				rcl		al,1					; rotate carry into bit 0
				add		al,30h					; encode in ASCII
				stosb							; save binary bit data
				dec		ecx						; decrement count
				jne		fmtBinary				; do for the rest of the bits
				
				jmp		fmtNullStr				; terminate the string
	
				;*====	Format the port data in hexadecimal	====
		fmtInstrHex:
				mov		al,[CurData]			; get port data
				mov		ah,al					; copy into AH
				shr		ah,4					; move into LS nybble
				and		ax,0f0fh				; accept only the lower nybbles
				add		ax,3030h				; encode in ASCII
				stosw							; save data
				jmp		fmtNullStr				; terminate string
		
				;*====	Prepare for the next instruction	====
		fmtInstnxt:			
				pop		ecx						; restore ECX
				pop		edx						;  & EDX
				inc		edx
				dec		ecx						; decrement line count
				
				jne		fmtinstrlp				;
				ret
Format_Instr	endp

;*==========================================================================*
;*			Routine to obtain all the handles for the controls				*
;*==========================================================================*
Init_Controls	proc	hWin:DWORD
				;*====	Get all the handles for the checkboxes	====
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX1		; checkbox 1 
				mov		[hCHECKBOX1],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX2		; checkbox 2
				mov		[hCHECKBOX2],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX3		; checkbox 3 
				mov		[hCHECKBOX3],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX4		; checkbox 4 
				mov		[hCHECKBOX4],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX5		; checkbox 5 
				mov		[hCHECKBOX5],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX6		; checkbox 6 
				mov		[hCHECKBOX6],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX7		; checkbox 7 
				mov		[hCHECKBOX7],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX8		; checkbox 8 
				mov		[hCHECKBOX8],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX9		; checkbox 9 
				mov		[hCHECKBOX9],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX10		; checkbox 10 
				mov		[hCHECKBOX10],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX11		; checkbox 11
				mov		[hCHECKBOX11],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX12		; checkbox 12 
				mov		[hCHECKBOX12],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX13		; checkbox 13 
				mov		[hCHECKBOX13],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX14		; checkbox 14 
				mov		[hCHECKBOX14],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX15		; checkbox 15 
				mov		[hCHECKBOX15],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX16		; checkbox 16 
				mov		[hCHECKBOX16],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX17		; checkbox 17 
				mov		[hCHECKBOX17],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX18		; checkbox 18 
				mov		[hCHECKBOX18],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX19		; checkbox 19 
				mov		[hCHECKBOX19],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX20		; checkbox 20
				mov		[hCHECKBOX20],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX21		; checkbox 21
				mov		[hCHECKBOX21],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX22		; checkbox 22 
				mov		[hCHECKBOX22],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX23		; checkbox 23
				mov		[hCHECKBOX23],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX24		; checkbox 24
				mov		[hCHECKBOX24],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOX25		; checkbox 25
				mov		[hCHECKBOX25],eax					; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_CHECKBOXPause	; checkbox pause
				mov		[hCHECKBOXPause],eax				; and its handle
		
				;*====	Get the handle for the labels for Port A Port Data	====
				invoke 	GetDlgItem,hWin,IDC_SPORTA0			; static label port A bit 0 data
				mov		[hSPORTA0],eax						; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_SPORTA1			; static label port A bit 1 data
				mov		[hSPORTA1],eax						; and its handle
				
				invoke 	GetDlgItem,hWin,IDC_SPORTA2			; static label port A bit 2 data
				mov		[hSPORTA2],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTA3			; static label port A bit 3 data
				mov		[hSPORTA3],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTA4			; static label port A bit 4 data
				mov		[hSPORTA4],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTA5			; static label port A bit 5 data
				mov		[hSPORTA5],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTA6			; static label port A bit 6 data
				mov		[hSPORTA6],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTA7			; static label port A bit 7 data
				mov		[hSPORTA7],eax						; and its handle
				
				;*====	Get the handle for the labels for Port A TRIS 	====
				invoke 	GetDlgItem,hWin,IDC_STRISA0			; static label TRIS A bit 0 data
				mov		[hSTRISA0],eax						; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_STRISA1			; static label TRIS A bit 1 data
				mov		[hSTRISA1],eax						; and its handle
				
				invoke 	GetDlgItem,hWin,IDC_STRISA2			; static label TRIS A bit 2 data
				mov		[hSTRISA2],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISA3			; static label TRIS A bit 3 data
				mov		[hSTRISA3],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISA4			; static label TRIS A bit 4 data
				mov		[hSTRISA4],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISA5			; static label TRIS A bit 5 data
				mov		[hSTRISA5],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISA6			; static label TRIS A bit 6 data
				mov		[hSTRISA6],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISA7			; static label TRIS A bit 7 data
				mov		[hSTRISA7],eax						; and its handle
				
				;*====	Get the handle for the labels for Port B Port Data	====
				invoke 	GetDlgItem,hWin,IDC_SPORTB0			; static label port B bit 0 data
				mov		[hSPORTB0],eax						; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_SPORTB1			; static label port B bit 1 data
				mov		[hSPORTB1],eax						; and its handle
				
				invoke 	GetDlgItem,hWin,IDC_SPORTB2			; static label port B bit 2 data
				mov		[hSPORTB2],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTB3			; static label port B bit 3 data
				mov		[hSPORTB3],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTB4			; static label port B bit 4 data
				mov		[hSPORTB4],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTB5			; static label port B bit 5 data
				mov		[hSPORTB5],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTB6			; static label port B bit 6 data
				mov		[hSPORTB6],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTB7			; static label port B bit 7 data
				mov		[hSPORTB7],eax						; and its handle
				
				;*====	Get the handle for the labels for Port B TRIS 	====
				invoke 	GetDlgItem,hWin,IDC_STRISB0			; static label TRIS B bit 0 data
				mov		[hSTRISB0],eax						; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_STRISB1			; static label TRIS B bit 1 data
				mov		[hSTRISB1],eax						; and its handle
				
				invoke 	GetDlgItem,hWin,IDC_STRISB2			; static label TRIS B bit 2 data
				mov		[hSTRISB2],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISB3			; static label TRIS B bit 3 data
				mov		[hSTRISB3],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISB4			; static label TRIS B bit 4 data
				mov		[hSTRISB4],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISB5			; static label TRIS B bit 5 data
				mov		[hSTRISB5],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISB6			; static label TRIS B bit 6 data
				mov		[hSTRISB6],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISB7			; static label TRIS B bit 7 data
				mov		[hSTRISB7],eax						; and its handle
				
				;*====	Get the handle for the labels for Port C Port Data	====
				invoke 	GetDlgItem,hWin,IDC_SPORTC0			; static label port C bit 0 data
				mov		[hSPORTC0],eax						; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_SPORTC1			; static label port C bit 1 data
				mov		[hSPORTC1],eax						; and its handle
				
				invoke 	GetDlgItem,hWin,IDC_SPORTC2			; static label port C bit 2 data
				mov		[hSPORTC2],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTC3			; static label port C bit 3 data
				mov		[hSPORTC3],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTC4			; static label port C bit 4 data
				mov		[hSPORTC4],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTC5			; static label port C bit 5 data
				mov		[hSPORTC5],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTC6			; static label port C bit 6 data
				mov		[hSPORTC6],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTC7			; static label port C bit 7 data
				mov		[hSPORTC7],eax						; and its handle
				
				;*====	Get the handle for the labels for Port A TRIS 	====
				invoke 	GetDlgItem,hWin,IDC_STRISC0			; static label TRIS C bit 0 data
				mov		[hSTRISC0],eax						; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_STRISC1			; static label TRIS C bit 1 data
				mov		[hSTRISC1],eax						; and its handle
				
				invoke 	GetDlgItem,hWin,IDC_STRISC2			; static label TRIS C bit 2 data
				mov		[hSTRISC2],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISC3			; static label TRIS C bit 3 data
				mov		[hSTRISC3],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISC4			; static label TRIS C bit 4 data
				mov		[hSTRISC4],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISC5			; static label TRIS C bit 5 data
				mov		[hSTRISC5],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISC6			; static label TRIS C bit 6 data
				mov		[hSTRISC6],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISC7			; static label TRIS C bit 7 data
				mov		[hSTRISC7],eax						; and its handle
				
				;*====	Get the handle for the labels for Port D Port Data	====
				invoke 	GetDlgItem,hWin,IDC_SPORTD0			; static label port D bit 0 data
				mov		[hSPORTD0],eax						; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_SPORTD1			; static label port D bit 1 data
				mov		[hSPORTD1],eax						; and its handle
				
				invoke 	GetDlgItem,hWin,IDC_SPORTD2			; static label port D bit 2 data
				mov		[hSPORTD2],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTD3			; static label port D bit 3 data
				mov		[hSPORTD3],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTD4			; static label port D bit 4 data
				mov		[hSPORTD4],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTD5			; static label port D bit 5 data
				mov		[hSPORTD5],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTD6			; static label port D bit 6 data
				mov		[hSPORTD6],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_SPORTD7			; static label port D bit 7 data
				mov		[hSPORTD7],eax						; and its handle
				
				;*====	Get the handle for the labels for Port D TRIS 	====
				invoke 	GetDlgItem,hWin,IDC_STRISD0			; static label TRIS D bit 0 data
				mov		[hSTRISD0],eax						; and its handle
		
				invoke 	GetDlgItem,hWin,IDC_STRISD1			; static label TRIS D bit 1 data
				mov		[hSTRISD1],eax						; and its handle
				
				invoke 	GetDlgItem,hWin,IDC_STRISD2			; static label TRIS D bit 2 data
				mov		[hSTRISD2],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISD3			; static label TRIS D bit 3 data
				mov		[hSTRISD3],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISD4			; static label TRIS D bit 4 data
				mov		[hSTRISD4],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISD5			; static label TRIS D bit 5 data
				mov		[hSTRISD5],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISD6			; static label TRIS D bit 6 data
				mov		[hSTRISD6],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STRISD7			; static label TRIS D bit 7 data
				mov		[hSTRISD7],eax						; and its handle
				
				;*====	Get the handle for the LEDs	====
				invoke 	GetDlgItem,hWin,IDC_STATICLED0		; static label LED 0 data
				mov		[hSLED0],eax						; and its handle
				
				invoke 	GetDlgItem,hWin,IDC_STATICLED1		; static label LED 1 data
				mov		[hSLED1],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STATICLED2		; static label LED 2 data
				mov		[hSLED2],eax						; and its handle
				invoke 	GetDlgItem,hWin,IDC_STATICLED3		; static label LED 3 data
				mov		[hSLED3],eax						; and its handle
				
				;*====	Get the handle for the buttons	====
				invoke 	GetDlgItem,hWin,IDC_BUTTONAccept	; accept button
				mov		[hbAccept],eax						; and its handle
				
				invoke 	GetDlgItem,hWin,IDC_BUTTONNSet		; new set button
				mov		[hbNSet],eax						; and its handle
				
				invoke 	GetDlgItem,hWin,IDC_BUTTONNGame		; new game button
				mov		[hbNGame],eax						; and its handle
				ret
Init_Controls	endp

;*==========================================================================*
;*				Routine to change the control text 							*
;*==========================================================================*
SetTextRoutine	proc	hWnd:DWORD, ControlID:DWORD, Strptr:DWORD

SetTextRoutine	endp

;*==========================================================================*
;*				Checkbox control routine 									*
;*==========================================================================*
ChkCtrlRoutine	proc	hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
				.if uMsg == WM_COMMAND
					mov		eax,wParam
					mov		edx,eax
					and		eax,0FFFFh
					shr		edx,16

					.if edx == BN_CLICKED
						;*====	Check through the list to check which control was clicked	====
						mov		esi,offset ChkCtrlIDs		; ESI -> checkbox table of IDs
						mov		edi,offset hCHECKBOX1		; EDI -> pointer to the start of the control handle
						
						sub		ecx,ecx						; reset ECX
						mov		ebx,ecx						; 
						mov		cx,[esi]					; CX = control count
						mov		dl,0						; set the bit number

						;*====	Check through all the checkboxes for clicked state	====
						.while cx > 0
							add		esi,2					; skip the current word data
							mov		bx,[esi]				; load the control ID for check
							
							;*====	Check the control ID that was clicked	====
							.if ax == bx					; was this control clicked?
								push	ebx					; save the registers first
								push	ecx
								push	edx
								push	edi					;
								push	esi
								
								invoke	IsDlgButtonChecked,esi,ebx
								
								pop		esi					; restore registers
								pop		edi
								pop		ecx					;
								pop		edx
								pop		ebx
								.if eax == 1				; checkbox checked
									mov		[CurCtrlHndle],edi	; save the address of the control's handle
									mov		[CurCtrlID],ebx		;  & it's handle
									sub		ecx,ecx			; exit from routine
								.endif
							.else
								add		edi,4				; go to next handle address
								inc		dl					; increment bit number
								
								;*====	Ensure that bit number < 8	====
								.if dl > 7
									sub		dl,dl			; reset to bit 0
								.endif
							.endif
							dec		ecx						; decrement control count
						.endw
					.endif
				.endif
ChkCtrlRoutine	endp
				
;*==========================================================================*
;*				Checkbox control routine 									*
;*==========================================================================*
CheckBoxRoutine	proc	hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
				.if uMsg == WM_COMMAND
					mov		eax,wParam
					mov		edx,eax
					and		eax,0FFFFh
					shr		edx,16
					.if edx == BN_CLICKED
						;*====	Check if checkbox is pressed	====
						mov		[ClickControl],1			; checkbox control clicked
						
						.if ax == IDC_CHECKBOX1
							invoke	IsDlgButtonChecked,hCHECKBOX1,IDC_CHECKBOX1
							.if eax == 1
								mov		[ClickedLine],00	; checkbox 1 is checked
							.endif
						.elseif ax == IDC_CHECKBOX2
							invoke	IsDlgButtonChecked,hCHECKBOX2,IDC_CHECKBOX2
							.if eax == 1
								mov		[ClickedLine],1			; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX3
							invoke	IsDlgButtonChecked,hCHECKBOX3,IDC_CHECKBOX3
							.if eax == 1
								mov		[ClickedLine],2			; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX4
							invoke	IsDlgButtonChecked,hCHECKBOX4,IDC_CHECKBOX4
							.if eax == 1
								mov		[ClickedLine],3			; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX5
							invoke	IsDlgButtonChecked,hCHECKBOX5,IDC_CHECKBOX5
							.if eax == 1
								mov		[ClickedLine],4			; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX6
							invoke	IsDlgButtonChecked,hCHECKBOX6,IDC_CHECKBOX6
							.if eax == 1
								mov		[ClickedLine],5			; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX7
							invoke	IsDlgButtonChecked,hCHECKBOX7,IDC_CHECKBOX7
							.if eax == 1
								mov		[ClickedLine],6			; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX8
							invoke	IsDlgButtonChecked,hCHECKBOX8,IDC_CHECKBOX8
							.if eax == 1
								mov		[ClickedLine],7			; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX9
							invoke	IsDlgButtonChecked,hCHECKBOX9,IDC_CHECKBOX9
							.if eax == 1
								mov		[ClickedLine],8			; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX10
							invoke	IsDlgButtonChecked,hCHECKBOX10,IDC_CHECKBOX10
							.if eax == 1
								mov		[ClickedLine],9			; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX11
							invoke	IsDlgButtonChecked,hCHECKBOX11,IDC_CHECKBOX11
							.if eax == 1
								mov		[ClickedLine],10		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX12
							invoke	IsDlgButtonChecked,hCHECKBOX12,IDC_CHECKBOX12
							.if eax == 1
								mov		[ClickedLine],11		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX13
							invoke	IsDlgButtonChecked,hCHECKBOX13,IDC_CHECKBOX13
							.if eax == 1
								mov		[ClickedLine],12		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX14
							invoke	IsDlgButtonChecked,hCHECKBOX14,IDC_CHECKBOX14
							.if eax == 1
								mov		[ClickedLine],13		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX15
							invoke	IsDlgButtonChecked,hCHECKBOX15,IDC_CHECKBOX15
							.if eax == 1
								mov		[ClickedLine],14		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX16
							invoke	IsDlgButtonChecked,hCHECKBOX16,IDC_CHECKBOX16
							.if eax == 1
								mov		[ClickedLine],15		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX17
							invoke	IsDlgButtonChecked,hCHECKBOX17,IDC_CHECKBOX17
							.if eax == 1
								mov		[ClickedLine],16		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX18
							invoke	IsDlgButtonChecked,hCHECKBOX18,IDC_CHECKBOX18
							.if eax == 1
								mov		[ClickedLine],17		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX19
							invoke	IsDlgButtonChecked,hCHECKBOX19,IDC_CHECKBOX19
							.if eax == 1
								mov		[ClickedLine],18		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX20
							invoke	IsDlgButtonChecked,hCHECKBOX20,IDC_CHECKBOX20
							.if eax == 1
								mov		[ClickedLine],19		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX21
							invoke	IsDlgButtonChecked,hCHECKBOX21,IDC_CHECKBOX21
							.if eax == 1
								mov		[ClickedLine],20		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX22
							invoke	IsDlgButtonChecked,hCHECKBOX22,IDC_CHECKBOX22
							.if eax == 1
								mov		[ClickedLine],21		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX23
							invoke	IsDlgButtonChecked,hCHECKBOX23,IDC_CHECKBOX23
							.if eax == 1
								mov		[ClickedLine],22		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX24
							invoke	IsDlgButtonChecked,hCHECKBOX24,IDC_CHECKBOX24
							.if eax == 1
								mov		[ClickedLine],23		; checkbox 
							.endif
						.elseif ax == IDC_CHECKBOX25
							invoke	IsDlgButtonChecked,hCHECKBOX25,IDC_CHECKBOX25
							.if eax == 1
								mov		[ClickedLine],24		; checkbox 
							.endif
						.endif
					.endif
				.Else
					MOV 	EAX,FALSE
					RET
				.EndIf
	
				MOV EAX,TRUE
				ret
CheckBoxRoutine	endp

;*==========================================================================*
;*				Label control routine 										*
;*==========================================================================*
LblCtrlRoutine	proc	hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
				.if uMsg == WM_COMMAND
					mov		eax,wParam
					mov		edx,eax
					and		eax,0FFFFh
					shr		edx,16
					.if edx == BN_CLICKED
						;*====	Check through the list to check which control was clicked	====
						mov		esi,offset LblPortAIDs		; ESI -> label table of IDs
						mov		edi,offset hSPORTA0			; EDI -> pointer to the start of the control handle
						
						sub		ecx,ecx						; reset ECX
						mov		ebx,ecx						; 
						mov		cx,[esi]					; CX = control count
						mov		dl,0						; set the bit number
						mov		[CurCtrlHndle],0			; default to no handle address
						mov		[CurCtrlID],-1				;  & no ID
						
						.while cx > 0
							add		esi,2					; skip the current word data
							mov		bx,[esi]				; load the control ID for check
							
							;*====	Check the control ID that was clicked	====
							.if ax == bx					; was this control clicked?
								mov		[CurCtrlHndle],edi	; save the address of the control's handle
								mov		[CurCtrlID],ebx		;  & it's handle
								sub		ecx,ecx				; stop routine
							.else
								add		edi,4				; go to next handle address
								inc		dl					; increment bit number
								
								;*====	Ensure that bit number < 8	====
								.if dl > 7
									sub		dl,dl			; reset to bit 0
								.endif
							.endif
							dec		ecx						; decrement control count
						.endw
					.endif
				.endif
LblCtrlRoutine	endp
				
;*==========================================================================*
;*				Label control routine 										*
;*==========================================================================*
LabelRoutine	proc	hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
				.if uMsg == WM_COMMAND
					mov		eax,wParam
					mov		edx,eax
					and		eax,0FFFFh
					shr		edx,16
					.if edx == BN_CLICKED
						mov		[ClickControl],2			; Port A bit label control clicked
						mov		[ClickedLine],255			; default to not selected

						;*====	Process for Port A bit labels	====	
						.if ax == IDC_SPORTA0				; port A bit 0 label control
							mov		[ClickedLine],1			; bit 0 
						.elseif ax == IDC_SPORTA1			; port A bit 1 label control
							mov		[ClickedLine],2			; bit 1
						.elseif ax == IDC_SPORTA2			; port A bit 0 label control
							mov		[ClickedLine],3			; bit 2 
						.elseif ax == IDC_SPORTA3			; port A bit 1 label control
							mov		[ClickedLine],4			; bit 3
						.elseif ax == IDC_SPORTA4			; port A bit 0 label control
							mov		[ClickedLine],5			; bit 0 
						.elseif ax == IDC_SPORTA5			; port A bit 1 label control
							mov		[ClickedLine],6			; bit 1
						.elseif ax == IDC_SPORTA6			; port A bit 0 label control
							mov		[ClickedLine],7			; bit 2 
						.elseif ax == IDC_SPORTA7			; port A bit 1 label control
							mov		[ClickedLine],8			; bit 3
						.endif
						
						;*====	Process for Port B bit labels	====	
						.if [ClickedLine] == 255
							mov		[ClickControl],3		; Port B bit label control clicked
							.if ax == IDC_SPORTB0			; port B bit 0 label control
								mov		[ClickedLine],1		; bit 0 
							.elseif ax == IDC_SPORTB1		; port B bit 1 label control
								mov		[ClickedLine],2		; bit 1
							.elseif ax == IDC_SPORTB2		; port B bit 0 label control
								mov		[ClickedLine],3		; bit 2 
							.elseif ax == IDC_SPORTB3		; port B bit 1 label control
								mov		[ClickedLine],4		; bit 3
							.elseif ax == IDC_SPORTB4		; port B bit 0 label control
								mov		[ClickedLine],5		; bit 0 
							.elseif ax == IDC_SPORTB5		; port B bit 1 label control
								mov		[ClickedLine],6		; bit 1
							.elseif ax == IDC_SPORTB6		; port B bit 0 label control
								mov		[ClickedLine],7		; bit 2 
							.elseif ax == IDC_SPORTB7		; port B bit 1 label control
								mov		[ClickedLine],8		; bit 3
							.endif
						.endif
						
						;*====	Process for Port C bit labels	====	
						.if [ClickedLine] == 255
							mov		[ClickControl],4		; Port C bit label control clicked
							.if ax == IDC_SPORTC0			; port C bit 0 label control
								mov		[ClickedLine],1		; bit 0 
							.elseif ax == IDC_SPORTC1		; port C bit 1 label control
								mov		[ClickedLine],2		; bit 1
							.elseif ax == IDC_SPORTC2		; port C bit 0 label control
								mov		[ClickedLine],3		; bit 2 
							.elseif ax == IDC_SPORTC3		; port C bit 1 label control
								mov		[ClickedLine],4		; bit 3
							.elseif ax == IDC_SPORTC4		; port C bit 0 label control
								mov		[ClickedLine],5		; bit 0 
							.elseif ax == IDC_SPORTC5		; port C bit 1 label control
								mov		[ClickedLine],6		; bit 1
							.elseif ax == IDC_SPORTC6		; port C bit 0 label control
								mov		[ClickedLine],7		; bit 2 
							.elseif ax == IDC_SPORTC7		; port C bit 1 label control
								mov		[ClickedLine],8		; bit 3
							.endif
						.endif
						
						;*====	Process for Port D bit labels	====	
						.if [ClickedLine] == 255
							mov		[ClickControl],5		; Port D bit label control clicked
							.if ax == IDC_SPORTD0			; port D bit 0 label control
								mov		[ClickedLine],1		; bit 0 
							.elseif ax == IDC_SPORTD1		; port D bit 1 label control
								mov		[ClickedLine],2		; bit 1
							.elseif ax == IDC_SPORTD2		; port D bit 0 label control
								mov		[ClickedLine],3		; bit 2 
							.elseif ax == IDC_SPORTD3		; port D bit 1 label control
								mov		[ClickedLine],4		; bit 3
							.elseif ax == IDC_SPORTD4		; port D bit 0 label control
								mov		[ClickedLine],5		; bit 0 
							.elseif ax == IDC_SPORTD5		; port D bit 1 label control
								mov		[ClickedLine],6		; bit 1
							.elseif ax == IDC_SPORTD6		; port D bit 0 label control
								mov		[ClickedLine],7		; bit 2 
							.elseif ax == IDC_SPORTD7		; port D bit 1 label control
								mov		[ClickedLine],8		; bit 3
							.endif
						.endif
						
						;*====	Process for Tris A bit labels	====	
						.if [ClickedLine] == 255
							mov		[ClickControl],6		; TRIS A bit label control clicked
							.if ax == IDC_STRISA0			; tris A bit 0 label control
								mov		[ClickedLine],1		; bit 0 
							.elseif ax == IDC_STRISA1		; tris A bit 1 label control
								mov		[ClickedLine],2		; bit 1
							.elseif ax == IDC_STRISA2		; tris A bit 0 label control
								mov		[ClickedLine],3		; bit 2 
							.elseif ax == IDC_STRISA3		; tris A bit 1 label control
								mov		[ClickedLine],4		; bit 3
							.elseif ax == IDC_STRISA4		; tris A bit 0 label control
								mov		[ClickedLine],5		; bit 0 
							.elseif ax == IDC_STRISA5		; tris A bit 1 label control
								mov		[ClickedLine],6		; bit 1
							.elseif ax == IDC_STRISA6		; tris A bit 0 label control
								mov		[ClickedLine],7		; bit 2 
							.elseif ax == IDC_STRISA7		; tris A bit 1 label control
								mov		[ClickedLine],8		; bit 3
							.endif
						.endif
						
						;*====	Process for Tris B bit labels	====	
						.if [ClickedLine] == 255
							mov		[ClickControl],7		; TRIS B bit label control clicked
							.if ax == IDC_STRISB0			; tris B bit 0 label control
								mov		[ClickedLine],1		; bit 0 
							.elseif ax == IDC_STRISB1		; tris B bit 1 label control
								mov		[ClickedLine],2		; bit 1
							.elseif ax == IDC_STRISB2		; tris B bit 0 label control
								mov		[ClickedLine],3		; bit 2 
							.elseif ax == IDC_STRISB3		; tris B bit 1 label control
								mov		[ClickedLine],4		; bit 3
							.elseif ax == IDC_STRISB4		; tris B bit 0 label control
								mov		[ClickedLine],5		; bit 0 
							.elseif ax == IDC_STRISB5		; tris B bit 1 label control
								mov		[ClickedLine],6		; bit 1
							.elseif ax == IDC_STRISB6		; tris B bit 0 label control
								mov		[ClickedLine],7		; bit 2 
							.elseif ax == IDC_STRISB7		; tris B bit 1 label control
								mov		[ClickedLine],8		; bit 3
							.endif
						.endif					
						
						;*====	Process for Tris C bit labels	====	
						.if [ClickedLine] == 255
							mov		[ClickControl],8		; TRIS C bit label control clicked
							.if ax == IDC_STRISC0			; tris C bit 0 label control
								mov		[ClickedLine],1		; bit 0 
							.elseif ax == IDC_STRISC1		; tris C bit 1 label control
								mov		[ClickedLine],2		; bit 1
							.elseif ax == IDC_STRISC2		; tris C bit 0 label control
								mov		[ClickedLine],3		; bit 2 
							.elseif ax == IDC_STRISC3		; tris C bit 1 label control
								mov		[ClickedLine],4		; bit 3
							.elseif ax == IDC_STRISC4		; tris C bit 0 label control
								mov		[ClickedLine],5		; bit 0 
							.elseif ax == IDC_STRISC5		; tris C bit 1 label control
								mov		[ClickedLine],6		; bit 1
							.elseif ax == IDC_STRISC6		; tris C bit 0 label control
								mov		[ClickedLine],7		; bit 2 
							.elseif ax == IDC_STRISC7		; tris C bit 1 label control
								mov		[ClickedLine],8		; bit 3
							.endif
						.endif
						
						;*====	Process for Tris D bit labels	====	
						.if [ClickedLine] == 255
							mov		[ClickControl],9		; TRIS D bit label control clicked
							.if ax == IDC_STRISD0			; tris C bit 0 label control
								mov		[ClickedLine],1		; bit 0 
							.elseif ax == IDC_STRISD1		; tris C bit 1 label control
								mov		[ClickedLine],2		; bit 1
							.elseif ax == IDC_STRISD2		; tris C bit 0 label control
								mov		[ClickedLine],3		; bit 2 
							.elseif ax == IDC_STRISD3		; tris C bit 1 label control
								mov		[ClickedLine],4		; bit 3
							.elseif ax == IDC_STRISD4		; tris C bit 0 label control
								mov		[ClickedLine],5		; bit 0 
							.elseif ax == IDC_STRISD5		; tris C bit 1 label control
								mov		[ClickedLine],6		; bit 1
							.elseif ax == IDC_STRISD6		; tris C bit 0 label control
								mov		[ClickedLine],7		; bit 2 
							.elseif ax == IDC_STRISD7		; tris C bit 1 label control
								mov		[ClickedLine],8		; bit 3
							.endif
						.endif
						
						;*====	Process the label clicked	====
						.if [ClickedLine] == 255
							;**		Process the clicked label	====
						.endif
					.endif
				.endif
LabelRoutine	endp
				
;*==========================================================================*
;*				Tab page 1 controls routine 								*
;*==========================================================================*
DialogOneProc	Proc hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
				.If uMsg == WM_INITDIALOG
					;*====	Initial tab 1 for processing	====
					invoke	Init_Controls,hWnd				; get handles to most of the controls
					
					
			
				.elseif uMsg == WM_COMMAND
					mov		eax,wParam
					mov		edx,eax
					and		eax,0FFFFh
					shr		edx,16
					.if edx == BN_CLICKED
						mov		[CurCtrlHndle],0			; default to no handle address
						mov		[CurCtrlID],-1				;  & no ID
						
						invoke	ChkCtrlRoutine, hWnd, uMsg, wParam, lParam
						
						mov		eax,[CurCtrlID] 			; get the return control ID
						.if eax == -1						; no checkbox clicked
							invoke	LblCtrlRoutine, hWnd, uMsg, wParam, lParam
						.endif
					.endif
				.Else
					MOV 	EAX,FALSE
					RET
				.EndIf
	
				MOV EAX,TRUE
				RET

DialogOneProc	EndP

DialogTwoProc Proc hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	.If uMsg == WM_INITDIALOG
	
	.Else
		MOV EAX,FALSE
		RET
	.EndIf
	
	MOV EAX,TRUE
	RET

DialogTwoProc EndP

DialogThreeProc Proc hWnd:DWORD, uMsg:DWORD,wParam:DWORD,lParam:DWORD
	
	.If uMsg == WM_INITDIALOG
	
	.Else
		MOV EAX,FALSE
		RET
	.EndIf
	
	MOV EAX,TRUE
	RET

DialogThreeProc EndP

DlgProc	Proc hWnd:DWORD, uMsg:DWORD, wParam:DWORD, lParam:DWORD
Local TCItem		:TC_ITEM

	.If uMsg == WM_INITDIALOG
		MOV TCItem.imask,TCIF_TEXT or TCIF_PARAM
		MOV TCItem.cchTextMax,64
		
		;2
;		Invoke CreateDialogParam,hInstance,IDD_DLG3,hWnd,Offset DialogThreeProc,0
;		MOV TCItem.pszText,Offset szThree
;		MOV TCItem.lParam,EAX
;		Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_INSERTITEM,0,ADDR TCItem
		
		;1
;		Invoke CreateDialogParam,hInstance,IDD_DLG2,hWnd,Offset DialogTwoProc,0
;		MOV TCItem.pszText,Offset szTwo
;		MOV TCItem.lParam,EAX
;		Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_INSERTITEM,0,ADDR TCItem
		
		
		;0
		Invoke CreateDialogParam,hInstance,IDD_DLG1,hWnd,Offset DialogOneProc,0
		MOV TCItem.pszText,Offset szuChip
		MOV TCItem.lParam,EAX
		
		;Store handle of the visible child dialog
		Invoke SetWindowLong,hWnd,GWL_USERDATA,TCItem.lParam
		
		Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_INSERTITEM,0,ADDR TCItem
		
		Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_SETCURSEL,0,0
		
		;*====	Initialize random routine	====
		call	InitRndmNbr					; initialize the seed for generating random numebrs
		
		;*====	Initialize all variables	====
		mov		[RunLine],0						;  reset game running line number
		mov		[CurLine],0						;   & set running line number
		mov		[CurSet],0						;   & current set 
		mov		[CurGame],0						;   & current game 
		mov		[CurErr],0						;   & current error
		mov		[ClickedLine],0					;   & clicked checkbox number 
		mov		[CurState],0					;   & current state
		
	.ElseIf uMsg == WM_NOTIFY
		MOV EDX, lParam
		
		.If [EDX].NMHDR.code == TCN_SELCHANGE
			
			Invoke GetWindowLong,hWnd,GWL_USERDATA
			Invoke ShowWindow,EAX,SW_HIDE
			
			Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_GETCURSEL,0,0
			MOV TCItem.imask,TCIF_PARAM
			MOV EDX,EAX
			Invoke SendDlgItemMessage,hWnd,IDC_TABCONTROL,TCM_GETITEM,EDX,ADDR TCItem
			
			Invoke SetWindowLong,hWnd,GWL_USERDATA,TCItem.lParam
			Invoke ShowWindow,TCItem.lParam,SW_SHOW
			
		.EndIf
		
	.ElseIf	uMsg == WM_COMMAND
		.If	wParam == IDC_OK
			
			Invoke EndDialog,hWnd,0
			
		.EndIf
		
	.ElseIf	uMsg == WM_CLOSE
		
		Invoke	EndDialog,hWnd,0
		
	.EndIf

	XOR	EAX,EAX
	RET
DlgProc	EndP

;*==========================================================================*
;*			Table containing all the IDs of the controls					*
;*==========================================================================*
ChkCtrlIDs		dw		26						; 26 checkboxes
				dw		IDC_CHECKBOX1			; instruction 1 checkbox
				dw		IDC_CHECKBOX2			; 2
				dw		IDC_CHECKBOX3			; 3
				dw		IDC_CHECKBOX4			; 4
				dw		IDC_CHECKBOX5			;5
				dw		IDC_CHECKBOX6			;6
				dw		IDC_CHECKBOX7			;7
				dw		IDC_CHECKBOX8			;8
				dw		IDC_CHECKBOX9			;9
				dw		IDC_CHECKBOX10			;10
				dw		IDC_CHECKBOX11			;11
				dw		IDC_CHECKBOX12			;12
				dw		IDC_CHECKBOX13			;13
				dw		IDC_CHECKBOX14			;14
				dw		IDC_CHECKBOX15			;15
				dw		IDC_CHECKBOX16			;16
				dw		IDC_CHECKBOX17			;17
				dw		IDC_CHECKBOX18			;18
				dw		IDC_CHECKBOX19			;19
				dw		IDC_CHECKBOX20			;20
				dw		IDC_CHECKBOX21			;21
				dw		IDC_CHECKBOX22			;22
				dw		IDC_CHECKBOX23			;23
				dw		IDC_CHECKBOX24			;24
				dw		IDC_CHECKBOX25			;25
				dw		IDC_CHECKBOXPause		;26

;*==========================================================================*
;*			Table containing all the IDs of the controls					*
;*==========================================================================*
LblPortAIDs		dw		64						; 16 labels or total of 64 including the 4 ports
				dw		IDC_SPORTA0				; port A bit 0
				dw		IDC_SPORTA1				; bit 1
				dw		IDC_SPORTA2				; bit 2
				dw		IDC_SPORTA3				; bit 3
				dw		IDC_SPORTA4				; bit 4
				dw		IDC_SPORTA5				; bit 5
				dw		IDC_SPORTA6				; bit 6
				dw		IDC_SPORTA7				; bit 7
				dw		IDC_STRISA0				; tris A bit 0
				dw		IDC_STRISA1				; bit 1
				dw		IDC_STRISA2				; bit 2
				dw		IDC_STRISA3				; bit 3
				dw		IDC_STRISA4				; bit 4
				dw		IDC_STRISA5				; bit 5
				dw		IDC_STRISA6				; bit 6
				dw		IDC_STRISA7				; bit 7

LblPortBIDs		dw		IDC_SPORTB0				; port A bit 0
				dw		IDC_SPORTB1				; bit 1
				dw		IDC_SPORTB2				; bit 2
				dw		IDC_SPORTB3				; bit 3
				dw		IDC_SPORTB4				; bit 4
				dw		IDC_SPORTB5				; bit 5
				dw		IDC_SPORTB6				; bit 6
				dw		IDC_SPORTB7				; bit 7
				dw		IDC_STRISB0				; tris A bit 0
				dw		IDC_STRISB1				; bit 1
				dw		IDC_STRISB2				; bit 2
				dw		IDC_STRISB3				; bit 3
				dw		IDC_STRISB4				; bit 4
				dw		IDC_STRISB5				; bit 5
				dw		IDC_STRISB6				; bit 6
				dw		IDC_STRISB7				; bit 7

LblPortCIDs		dw		IDC_SPORTC0				; port A bit 0
				dw		IDC_SPORTC1				; bit 1
				dw		IDC_SPORTC2				; bit 2
				dw		IDC_SPORTC3				; bit 3
				dw		IDC_SPORTC4				; bit 4
				dw		IDC_SPORTC5				; bit 5
				dw		IDC_SPORTC6				; bit 6
				dw		IDC_SPORTC7				; bit 7
				dw		IDC_STRISC0				; tris A bit 0
				dw		IDC_STRISC1				; bit 1
				dw		IDC_STRISC2				; bit 2
				dw		IDC_STRISC3				; bit 3
				dw		IDC_STRISC4				; bit 4
				dw		IDC_STRISC5				; bit 5
				dw		IDC_STRISC6				; bit 6
				dw		IDC_STRISC7				; bit 7

LblPortDIDs		dw		IDC_SPORTD0				; port A bit 0
				dw		IDC_SPORTD1				; bit 1
				dw		IDC_SPORTD2				; bit 2
				dw		IDC_SPORTD3				; bit 3
				dw		IDC_SPORTD4				; bit 4
				dw		IDC_SPORTD5				; bit 5
				dw		IDC_SPORTD6				; bit 6
				dw		IDC_SPORTD7				; bit 7
				dw		IDC_STRISD0				; tris A bit 0
				dw		IDC_STRISD1				; bit 1
				dw		IDC_STRISD2				; bit 2
				dw		IDC_STRISD3				; bit 3
				dw		IDC_STRISD4				; bit 4
				dw		IDC_STRISD5				; bit 5
				dw		IDC_STRISD6				; bit 6
				dw		IDC_STRISD7				; bit 7



Start:

	Invoke	GetModuleHandle, NULL
	MOV	hInstance, EAX
	Invoke InitCommonControls
	Invoke	DialogBoxParam, hInstance, IDD_MAIN, 0, ADDR DlgProc, 0
	Invoke	ExitProcess, EAX

End Start
